﻿Public Class Form1
    #Region "Class ClsPWatch : コンボボックス用."
        Public Class ClsPWatch
            Public PName As String = Nothing
            Public PWatch As NSDPrinterWatch = Nothing

            #Region "Property Name : 名前を返します."
                Public ReadOnly Property Name() As String
                    Get
                        Return PName
                    End Get
                End Property
            #End Region
        End Class
    #End Region

    #Region "デリゲート宣言."
        Delegate Sub AddContents_Invoke(ByVal ObjVal_Data() As Object)
    #End Region

    #Region "Form1イベント."
        #Region "Sub Form1_FormClosing : FormClosingイベント."
            Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
                Try
                    For Int_Loop As Integer = 0 To Cmb_Printer.Items.Count - 1
                        Dim SelectItem As ClsPWatch = CType(Me.Cmb_Printer.Items(Int_Loop), ClsPWatch)
                        With SelectItem
                            .PWatch.Dispose()
                            .PWatch = Nothing
                        End With
                    Next
                Catch ex As Exception

                End Try
            End Sub
        #End Region

        #Region "Sub Form1_Load : Loadイベント."
            Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
                Try
                    MsgBox("このプログラムは、関数のサンプルプログラムです。")

                    Using Cls_Pw As New NSDPrinterWatch
                        Dim Str_PrinterName() As String = Nothing
                        Cls_Pw.GetPrinterList(Str_PrinterName)
                        If (Str_PrinterName Is Nothing) OrElse _
                            (Str_PrinterName.Length = 0) Then
                            MsgBox("インストールされているプリンタが見つかりません。")
                            End
                        Else
                            Cmb_Printer.DisplayMember = "Name"
                            For Int_Loop As Integer = 0 To Str_PrinterName.Length - 1
                                Dim ClsItem As New ClsPWatch
                                ClsItem.PName = Str_PrinterName(Int_Loop)
                                ClsItem.PWatch = New NSDPrinterWatch()

                                Cmb_Printer.Items.Add(ClsItem)
                            Next
                            Cmb_Printer.SelectedIndex = 0
                        End If
                    End Using

                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Btn_Watch_Click : 監視有無用のボタンクリック."
        Private Sub Btn_Watch_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_Watch.Click
            Try
                If Not (Me.Cmb_Printer.SelectedItem Is Nothing) Then
                    Dim SelectItem As ClsPWatch = CType(Me.Cmb_Printer.SelectedItem, ClsPWatch)
                    With SelectItem
                        If .PWatch.Watch Then
                            ' 監視中なので、監視を中止します.
                            WatchStop(.PWatch)
                            Cmb_Printer_SelectedIndexChanged_Sub(SelectItem)
                        Else
                            ' 監視を行います.
                            Dim Int_General_Flags As NSDPrinterWatch.Printer_Change_Notification_General_Flags = 0
                            If Me.Chk_NotificationContents01.Checked Then
                                ' フォームへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_FORM
                            End If
                            If Me.Chk_NotificationContents02.Checked Then
                                ' ポートへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PORT
                            End If
                            If Me.Chk_NotificationContents03.Checked Then
                                ' ジョブへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_JOB
                            End If
                            If Me.Chk_NotificationContents04.Checked Then
                                ' プリンタへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINTER
                            End If
                            If Me.Chk_NotificationContents05.Checked Then
                                ' プリントプロセッサへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINT_PROCESSOR
                            End If
                            If Me.Chk_NotificationContents06.Checked Then
                                ' プリンタドライバへの変更時に通知する.
                                Int_General_Flags = Int_General_Flags Or NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINTER_DRIVER
                            End If
                            If Int_General_Flags = 0 Then
                                MsgBox("通知内容が一つもチェックされていません。")
                            Else
                                Dim Int_NotificationStyle As NSDPrinterWatch.NSD_NotificationStyle
                                If Me.RB_NotificationStyle01.Checked Then
                                    Int_NotificationStyle = NSDPrinterWatch.NSD_NotificationStyle.Job_Notification
                                ElseIf Me.RB_NotificationStyle02.Checked Then
                                    Int_NotificationStyle = NSDPrinterWatch.NSD_NotificationStyle.Printer_Notification
                                Else
                                    Int_NotificationStyle = NSDPrinterWatch.NSD_NotificationStyle.Both
                                End If
                                If .PWatch.PrinterWatch(SelectItem.PName, Int_General_Flags, Int_NotificationStyle) Then
                                    AddHandler .PWatch.Event_Change_Notification, AddressOf Change_Notification
                                    Cmb_Printer_SelectedIndexChanged_Sub(SelectItem)
                                Else
                                    MsgBox("監視が正常に行えていません。")
                                End If
                            End If
                        End If
                    End With
                End If
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub WatchStop : 監視を中止します."
        Private Sub WatchStop(ByVal ClsVal_PWatch As NSDPrinterWatch)
            Try
                ClsVal_PWatch.PrinterWatchEnd()
                RemoveHandler ClsVal_PWatch.Event_Change_Notification, AddressOf Change_Notification
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_Printer_SelectedIndexChanged : プリンタの選択."
        Private Sub Cmb_Printer_SelectedIndexChanged( sender As System.Object,  e As System.EventArgs) Handles Cmb_Printer.SelectedIndexChanged
            Try
                Dim SelectItem As ClsPWatch = CType(CType(sender,ComboBox).SelectedItem, ClsPWatch)
                Cmb_Printer_SelectedIndexChanged_Sub(SelectItem)

            Catch ex As Exception

            End Try
        End Sub

        #Region "Sub Cmb_Printer_SelectedIndexChanged_Sub : プリンタ選択(サブ)."
            Private Sub Cmb_Printer_SelectedIndexChanged_Sub(ByVal ClsVal_PWatch As ClsPWatch)
                Try
                    With ClsVal_PWatch.PWatch
                        If .Watch Then
                            Me.Lbl_WatchState.Text = "監視しています。"
                            Me.Btn_Watch.Text = "監視を止めます"

                            ' フォームへの変更時に通知する.
                            Me.Chk_NotificationContents01.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_FORM
                            ' ポートへの変更時に通知する.
                            Me.Chk_NotificationContents02.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PORT
                            ' ジョブへの変更時に通知する.
                            Me.Chk_NotificationContents03.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_JOB
                            ' プリンタへの変更時に通知する.
                            Me.Chk_NotificationContents04.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINTER
                            ' プリントプロセッサへの変更時に通知する.
                            Me.Chk_NotificationContents05.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINT_PROCESSOR
                            ' プリンタドライバへの変更時に通知する.
                            Me.Chk_NotificationContents06.Checked = .WatchFlag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINTER_DRIVER

                            Me.GB_NotificationStyle.Enabled = False
                            Me.GB_NotificationContents.Enabled = False
                        Else
                            Me.Lbl_WatchState.Text = "監視していません。"
                            Me.Btn_Watch.Text = "監視を行う"

                            ' フォームへの変更時に通知する.
                            Me.Chk_NotificationContents01.Checked = True
                            ' ポートへの変更時に通知する.
                            Me.Chk_NotificationContents02.Checked = True
                            ' ジョブへの変更時に通知する.
                            Me.Chk_NotificationContents03.Checked = True
                            ' プリンタへの変更時に通知する.
                            Me.Chk_NotificationContents04.Checked = True
                            ' プリントプロセッサへの変更時に通知する.
                            Me.Chk_NotificationContents05.Checked = True
                            ' プリンタドライバへの変更時に通知する.
                            Me.Chk_NotificationContents06.Checked = True

                            Me.GB_NotificationStyle.Enabled = True
                            Me.GB_NotificationContents.Enabled = True
                        End If
                    End With

                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Change_Notification : 変更通知."
        Sub Change_Notification( ByVal Sender As NSDPrinterWatch, _
                                 ByVal IntVal_General_Flag As NSDPrinterWatch.Printer_Change_Notification_General_Flags, _
                                 ByVal IntVal_NotificationFlags As Integer, _
                                 ByVal ClsNotifyInfo As NSDPrinterWatch.NSDPrinterNotifyInfo, _
                                 ByVal Time As Date )
            Try
                If IntVal_General_Flag = -1 AndAlso _
                    IntVal_NotificationFlags = -1 Then
                    MsgBox("変更通知が受け取れないエラーが発生しました。")
                    ' 監視中なので、監視を中止します.
                    WatchStop(Sender)
                Else
                    ' 内容を取得します.
                        Dim Str_Contents() As String = Nothing
                        Sender.GetEventsContens(IntVal_General_Flag, IntVal_NotificationFlags, Str_Contents)
                        Dim Str_Msg As String = Nothing
                        For Int_Loop As Integer = 0 To Str_Contents.Length - 1
                            Str_Msg = Str_Msg & Str_Contents(Int_Loop) & ControlChars.CrLf
                        Next

                        If Str_Contents.Length >= 2 Then
                            Dim Int_A As Int16 = 0
                        End If

                    ' プリンター名を取得します.
                        Dim Str_PrinterName As String = Sender.PrinterName

                    ' 内容を追加します.
                        Dim Obj_Args(0 To 2) As Object
                        Obj_Args(0) = Time
                        Obj_Args(2) = Str_PrinterName
                        For Int_Loop As Integer = 0 To Str_Contents.Length - 1
                            Obj_Args(1) = Str_Contents(Int_Loop)
                            If Me.InvokeRequired Then
                                Me.Invoke(New AddContents_Invoke(AddressOf AddContents), New Object() {Obj_Args} )
                            Else
                                AddContents(Obj_Args)
                            End If
                        Next

                    ' 
                    Dim Str_DebugMsg As String = Nothing
                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_FORM) Then
                            ’フォーム(用紙)の変更通知.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Form_Flags.PRINTER_CHANGE_ADD_FORM) Then
                                ' サーバーに用紙が追加されました。
                                Str_DebugMsg &= "サーバーに用紙が追加されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Form_Flags.PRINTER_CHANGE_SET_FORM) Then
                                ' サーバ上で用紙が設定されました。
                                Str_DebugMsg &= "サーバ上で用紙が設定されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Form_Flags.PRINTER_CHANGE_DELETE_FORM) Then
                                ' サーバーから用紙が削除されました。
                                Str_DebugMsg &= "サーバーから用紙が削除されました。" & ControlChars.CrLf
                            End If
                        End If

                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PORT) Then
                            ' ポートの変更通知.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Port_Flags.PRINTER_CHANGE_ADD_PORT) Then
                                ' サーバーにポートまたはモニタが追加されました。
                                Str_DebugMsg &= "サーバーにポートまたはモニタが追加されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Port_Flags.PRINTER_CHANGE_CONFIGURE_PORT) Then
                                ' サーバー上でポートが設定されました。
                                Str_DebugMsg &= "サーバー上でポートが設定されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Port_Flags.PRINTER_CHANGE_DELETE_PORT) Then
                                ' サーバーからポートまたはモニタが削除されました。
                                Str_DebugMsg &= "サーバーからポートまたはモニタが削除されました。" & ControlChars.CrLf
                            End If
                        End If

                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_JOB) Then
                            ' ジョブに対する変更通知条件.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Job_Flags.PRINTER_CHANGE_ADD_JOB) Then
                                ' プリンタに印刷ジョブが送信されました。
                                Str_DebugMsg &= "プリンタに印刷ジョブが送信されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Job_Flags.PRINTER_CHANGE_SET_JOB) Then
                                ' ジョブが設定されました。
                                Str_DebugMsg &= "ジョブが設定されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Job_Flags.PRINTER_CHANGE_DELETE_JOB) Then
                                ' ジョブが削除されました。
                                Str_DebugMsg &= "ジョブが削除されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Job_Flags.PRINTER_CHANGE_WRITE_JOB) Then
                                ' ジョブデータが書き込まれました。
                                Str_DebugMsg &= "ジョブデータが書き込まれました。" & ControlChars.CrLf
                            End If
                        End If

                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINTER) Then
                            ' プリンターの変更通知.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Printer_Flags.PRINTER_CHANGE_ADD_PRINTER) Then
                                ' サーバーにプリンタが追加されました。
                                Str_DebugMsg &= "サーバーにプリンタが追加されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Printer_Flags.PRINTER_CHANGE_SET_PRINTER) Then
                                ' プリンタが設定されました。
                                Str_DebugMsg &= "プリンタが設定されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Printer_Flags.PRINTER_CHANGE_DELETE_PRINTER) Then
                                ' プリンタが削除されました。
                                Str_DebugMsg &= "プリンタが削除されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Printer_Flags.PRINTER_CHANGE_FAILED_CONNECTION_PRINTER) Then
                                ' プリンタへの接続に失敗しました。
                                Str_DebugMsg &= "プリンタへの接続に失敗しました。" & ControlChars.CrLf
                            End If
                        End If

                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINT_PROCESSOR) Then
                            ' プリントプロセッサの変更通知.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Processor_Flags.PRINTER_CHANGE_ADD_PRINT_PROCESSOR) Then
                                ' サーバーにプリントプロセッサが追加されました。
                                Str_DebugMsg &= "サーバーにプリントプロセッサが追加されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Processor_Flags.PRINTER_CHANGE_DELETE_PRINT_PROCESSOR) Then
                                ' サーバーからプリントプロセッサが削除されました。
                                Str_DebugMsg &= "サーバーからプリントプロセッサが削除されました。" & ControlChars.CrLf
                            End If
                        End If

                        If (IntVal_General_Flag And NSDPrinterWatch.Printer_Change_Notification_General_Flags.PRINTER_CHANGE_PRINT_PROCESSOR) Then
                            ' プリンタードライバーの変更通知.
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Driver_Flags.PRINTER_CHANGE_ADD_PRINTER_DRIVER) Then
                                ' サーバーにプリンタドライバが追加されました。
                                Str_DebugMsg &= "サーバーにプリンタドライバが追加されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Driver_Flags.PRINTER_CHANGE_SET_PRINTER_DRIVER) Then
                                ' プリンタドライバが設定されました。
                                Str_DebugMsg &= "プリンタドライバが設定されました。" & ControlChars.CrLf
                            End If
                            If (IntVal_NotificationFlags And NSDPrinterWatch.Printer_Change_Notification_Driver_Flags.PRINTER_CHANGE_DELETE_PRINTER_DRIVER) Then
                                ' サーバーからプリンタドライバが削除されました。
                                Str_DebugMsg &= "サーバーからプリンタドライバが削除されました。" & ControlChars.CrLf
                            End If
                        End If

                        If Not ClsNotifyInfo.JobInfoCollection Is Nothing Then
                            ' 印刷ジョブの通知情報が存在します.
                            Dim Int_JobInfoCount As Integer = 1
                            For Each OneJob As NSDPrinterWatch.NSDPrintJob In ClsNotifyInfo.JobInfoCollection
                                ' 一つの印刷ジョブ情報.
                                Dim Str_JobMsg As String = Nothing
                                Dim Str_JobInfoCount As String = "(" & Int_JobInfoCount.ToString & ")"
                                Str_JobMsg = "印刷ジョブの名前" & Str_JobInfoCount & "：" & OneJob.DocumentName & ControlChars.CrLf
                                Str_JobMsg &= "マシンの名前" & Str_JobInfoCount & "：" & OneJob.MachineName & ControlChars.CrLf
                                Str_JobMsg &= "ユーザーの名前" & Str_JobInfoCount & "：" & OneJob.UserName & ControlChars.CrLf
                                Str_DebugMsg &= Str_JobMsg
                                Int_JobInfoCount += 1
                            Next
                        End If

                        If Not ClsNotifyInfo.PrintInfoCollection Is Nothing Then
                            ' プリンタ通知情報が存在します.
                            Dim Int_PrintNotifyInfoCount As Integer = 1
                            For Each OnePrintNotify As NSDPrinterWatch.NSDPrintNotification In ClsNotifyInfo.PrintInfoCollection
                                Dim Str_PrintNotifyMsg As String = Nothing
                                Dim Str_PrintNotifyInfoCount As String = "(" & Int_PrintNotifyInfoCount.ToString & ")"

                                Str_PrintNotifyMsg = "サーバーの名前" & Str_PrintNotifyInfoCount & "：" & OnePrintNotify.ServerName & ControlChars.CrLf
                                Str_PrintNotifyMsg &= "プリンタの名前" & Str_PrintNotifyInfoCount & "：" & OnePrintNotify.PrinterName & ControlChars.CrLf
                                Str_PrintNotifyMsg &= "出力ポートの名前" & Str_PrintNotifyInfoCount & "：" & OnePrintNotify.PortName & ControlChars.CrLf

                                Str_DebugMsg &= Str_PrintNotifyMsg
                                Int_PrintNotifyInfoCount += 1
                            Next
                        End If

                    Debug.WriteLine(Str_DebugMsg)

                End If
            Catch ex As Exception

            End Try
        End Sub

        #Region "Sub AddContents : 内容を追加します."
            Public Sub AddContents(ByVal ObjVal_Data() As Object)
                Try
                    Dim OneItem As ListViewItem = Me.LV_Events.Items.Add(ObjVal_Data(0).ToString())
                    OneItem.SubItems.Add(ObjVal_Data(1))
                    OneItem.SubItems.Add(ObjVal_Data(2))
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Btn_ListClear_Click : リストのクリア."
        Private Sub Btn_ListClear_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_ListClear.Click
            Try
                Me.LV_Events.Items.Clear()
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region
End Class
